/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.reseller.model;

import com.google.api.client.json.GenericJson;
import com.google.api.client.json.JsonString;

/**
 * JSON template for a subscription.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Enterprise Apps Reseller API. For a detailed
 * explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Subscription extends GenericJson {

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @JsonString
  private Long creationTime;

  /**
   * The id of the customer to whom the subscription belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String customerId;

  /**
   * Identifies the resource as a Subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Plan details of the subscription
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Plan plan;

  /**
   * Purchase order id for your order tracking purposes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String purchaseOrderId;

  /**
   * Renewal settings of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private RenewalSettings renewalSettings;

  /**
   * Number/Limit of seats in the new plan.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Seats seats;

  /**
   * Name of the sku for which this subscription is purchased.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String skuId;

  /**
   * Status of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String status;

  /**
   * The id of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String subscriptionId;

  /**
   * Trial Settings of the subscription.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TrialSettings trialSettings;

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * The value returned may be {@code null}.
   */
  public Long getCreationTime() {
    return creationTime;
  }

  /**
   * Creation time of this subscription in milliseconds since Unix epoch.
   * The value set may be {@code null}.
   */
  public Subscription setCreationTime(Long creationTime) {
    this.creationTime = creationTime;
    return this;
  }

  /**
   * The id of the customer to whom the subscription belongs.
   * The value returned may be {@code null}.
   */
  public String getCustomerId() {
    return customerId;
  }

  /**
   * The id of the customer to whom the subscription belongs.
   * The value set may be {@code null}.
   */
  public Subscription setCustomerId(String customerId) {
    this.customerId = customerId;
    return this;
  }

  /**
   * Identifies the resource as a Subscription.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Identifies the resource as a Subscription.
   * The value set may be {@code null}.
   */
  public Subscription setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Plan details of the subscription
   * The value returned may be {@code null}.
   */
  public Plan getPlan() {
    return plan;
  }

  /**
   * Plan details of the subscription
   * The value set may be {@code null}.
   */
  public Subscription setPlan(Plan plan) {
    this.plan = plan;
    return this;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * The value returned may be {@code null}.
   */
  public String getPurchaseOrderId() {
    return purchaseOrderId;
  }

  /**
   * Purchase order id for your order tracking purposes.
   * The value set may be {@code null}.
   */
  public Subscription setPurchaseOrderId(String purchaseOrderId) {
    this.purchaseOrderId = purchaseOrderId;
    return this;
  }

  /**
   * Renewal settings of the subscription.
   * The value returned may be {@code null}.
   */
  public RenewalSettings getRenewalSettings() {
    return renewalSettings;
  }

  /**
   * Renewal settings of the subscription.
   * The value set may be {@code null}.
   */
  public Subscription setRenewalSettings(RenewalSettings renewalSettings) {
    this.renewalSettings = renewalSettings;
    return this;
  }

  /**
   * Number/Limit of seats in the new plan.
   * The value returned may be {@code null}.
   */
  public Seats getSeats() {
    return seats;
  }

  /**
   * Number/Limit of seats in the new plan.
   * The value set may be {@code null}.
   */
  public Subscription setSeats(Seats seats) {
    this.seats = seats;
    return this;
  }

  /**
   * Name of the sku for which this subscription is purchased.
   * The value returned may be {@code null}.
   */
  public String getSkuId() {
    return skuId;
  }

  /**
   * Name of the sku for which this subscription is purchased.
   * The value set may be {@code null}.
   */
  public Subscription setSkuId(String skuId) {
    this.skuId = skuId;
    return this;
  }

  /**
   * Status of the subscription.
   * The value returned may be {@code null}.
   */
  public String getStatus() {
    return status;
  }

  /**
   * Status of the subscription.
   * The value set may be {@code null}.
   */
  public Subscription setStatus(String status) {
    this.status = status;
    return this;
  }

  /**
   * The id of the subscription.
   * The value returned may be {@code null}.
   */
  public String getSubscriptionId() {
    return subscriptionId;
  }

  /**
   * The id of the subscription.
   * The value set may be {@code null}.
   */
  public Subscription setSubscriptionId(String subscriptionId) {
    this.subscriptionId = subscriptionId;
    return this;
  }

  /**
   * Trial Settings of the subscription.
   * The value returned may be {@code null}.
   */
  public TrialSettings getTrialSettings() {
    return trialSettings;
  }

  /**
   * Trial Settings of the subscription.
   * The value set may be {@code null}.
   */
  public Subscription setTrialSettings(TrialSettings trialSettings) {
    this.trialSettings = trialSettings;
    return this;
  }

  /**
   * Plan details of the subscription
   */
  public static final class Plan extends GenericJson {

    /**
     * Interval of the commitment if it is a commitment plan.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private CommitmentInterval commitmentInterval;

    /**
     * Whether the plan is a commitment plan or not.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Boolean isCommitmentPlan;

    /**
     * The plan name of this subscription's plan.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String planName;

    /**
     * Interval of the commitment if it is a commitment plan.
     * The value returned may be {@code null}.
     */
    public CommitmentInterval getCommitmentInterval() {
      return commitmentInterval;
    }

    /**
     * Interval of the commitment if it is a commitment plan.
     * The value set may be {@code null}.
     */
    public Plan setCommitmentInterval(CommitmentInterval commitmentInterval) {
      this.commitmentInterval = commitmentInterval;
      return this;
    }

    /**
     * Whether the plan is a commitment plan or not.
     * The value returned may be {@code null}.
     */
    public Boolean getIsCommitmentPlan() {
      return isCommitmentPlan;
    }

    /**
     * Whether the plan is a commitment plan or not.
     * The value set may be {@code null}.
     */
    public Plan setIsCommitmentPlan(Boolean isCommitmentPlan) {
      this.isCommitmentPlan = isCommitmentPlan;
      return this;
    }

    /**
     * The plan name of this subscription's plan.
     * The value returned may be {@code null}.
     */
    public String getPlanName() {
      return planName;
    }

    /**
     * The plan name of this subscription's plan.
     * The value set may be {@code null}.
     */
    public Plan setPlanName(String planName) {
      this.planName = planName;
      return this;
    }

    /**
     * Interval of the commitment if it is a commitment plan.
     */
    public static final class CommitmentInterval extends GenericJson {

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key @JsonString
      private Long endTime;

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * The value may be {@code null}.
       */
      @com.google.api.client.util.Key @JsonString
      private Long startTime;

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * The value returned may be {@code null}.
       */
      public Long getEndTime() {
        return endTime;
      }

      /**
       * End time of the commitment interval in milliseconds since Unix epoch.
       * The value set may be {@code null}.
       */
      public CommitmentInterval setEndTime(Long endTime) {
        this.endTime = endTime;
        return this;
      }

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * The value returned may be {@code null}.
       */
      public Long getStartTime() {
        return startTime;
      }

      /**
       * Start time of the commitment interval in milliseconds since Unix epoch.
       * The value set may be {@code null}.
       */
      public CommitmentInterval setStartTime(Long startTime) {
        this.startTime = startTime;
        return this;
      }

    }
  }

  /**
   * Trial Settings of the subscription.
   */
  public static final class TrialSettings extends GenericJson {

    /**
     * Whether the subscription is in trial.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private Boolean isInTrial;

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @JsonString
    private Long trialEndTime;

    /**
     * Whether the subscription is in trial.
     * The value returned may be {@code null}.
     */
    public Boolean getIsInTrial() {
      return isInTrial;
    }

    /**
     * Whether the subscription is in trial.
     * The value set may be {@code null}.
     */
    public TrialSettings setIsInTrial(Boolean isInTrial) {
      this.isInTrial = isInTrial;
      return this;
    }

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * The value returned may be {@code null}.
     */
    public Long getTrialEndTime() {
      return trialEndTime;
    }

    /**
     * End time of the trial in milliseconds since Unix epoch.
     * The value set may be {@code null}.
     */
    public TrialSettings setTrialEndTime(Long trialEndTime) {
      this.trialEndTime = trialEndTime;
      return this;
    }

  }
}
